
#include <TextFinder.h>
#include <SPI.h>
#include <Ethernet.h>
#include <LiquidCrystal_I2C.h>
#include <Wire.h>
LiquidCrystal_I2C lcd(0x27,16,2);  // set the LCD address to 0x20 for a 16 chars and 2 line display
                          // Number of visible characters in the text

int button_pin = 2;
// Initialize variable that will hold the push button state
int button_state = LOW;
int ledPin = 13;
int keyIndex = 0; 
String result ="";
String resultt ="";
String fermata ="s-srhvmp4sep-nocco2"; // via nocco, 2 Lecce // cambiare con il proprio onestop_id
//String fermata ="s-srhvt7x3sr-foscolo~fronteapi"; // rotatoria hotel tiziano lecce
const unsigned int scrollDelay = 300;   // Miliseconds before scrolling next char
const unsigned int demoDelay = 2000;    // Miliseconds between demo loops
byte textLen;                           // Number of visible characters in the text

// Enter a MAC address for your controller below.
// Newer Ethernet shields have a MAC address printed on a sticker on the shield
byte mac[] = { 0x5e, 0xa4, 0x18, 0xf0, 0x8a, 0xf6 };

IPAddress ip(192, 168, 0, 177);


char server[] = "www.piersoft.it";    // name address (using DNS)

EthernetClient client;

TextFinder finder(client);
unsigned long lastConnectionTime = 0;          
boolean lastConnected = false;                  
const unsigned long postingInterval = 1*1000;  

void setup() {
 lcd.init();                      // initialize the lcd 
  // Print a message to the LCD.
  lcd.backlight();

  pinMode(ledPin, OUTPUT); 
    pinMode(button_pin, INPUT_PULLUP);  
  digitalWrite(ledPin, LOW); 
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }
     Serial.println("sono qui");
    // give the Ethernet shield a second to initialize:
  delay(1000);
  Serial.println("connecting...");

//Ethernet.begin(mac, ip, gateway, subnet);  
  // start the Ethernet connection:
  if (Ethernet.begin(mac) == 0) {
    Serial.println("Failed to configure Ethernet using DHCP");
    // no point in carrying on, so do nothing forevermore:
    // try to congifure using IP address instead of DHCP:
   Ethernet.begin(mac,ip);  
  }else{

      Serial.println("ip ok");
      lcd.print("Pronto");
   }
 

}


void loop()
{

   button_state = digitalRead(button_pin); // pulled up to 5V by default 
  
  // Check if the push button is pressed. If it is, the button state is 
  // LOW because the button is connected to ground:
  if (button_state == LOW) 
  {
    // Turn LED on:    
   
        httpRequest();
   
    digitalWrite(ledPin, HIGH);  
    delay(200);
 
  }
  // otherwise (i.e., if button_state is HIGH)
  else 
  {
    // Turn LED off:
    digitalWrite(ledPin, LOW); 
     delay(200);
  }
  // if there are incoming bytes available
  // from the server, read them and print them:
  while (client.available()) {
   finder.find((char *) "|");
  char c = client.read();
 
  while(c != '!'){
    result += c;
    c = client.read();
  }
 
 resultt = result;

Serial.println(resultt);
scroll();

 //delay(50000);

 // setup();
  }



}

void httpRequest() {
 client.stop(); 
    if (client.connect(server, 80)) {
    Serial.println("connecting...piersoft");
    client.println("GET /gtfstutorial/orariarduino.php?id="+fermata+" HTTP/1.1");
    client.println("Host: www.piersoft.it");
    client.println("Connection: close");
    client.println();
  

 //   lastConnectionTime = millis();
  //  Serial.println(lastConnectionTime);
  
    }
  else {
    Serial.println("connection failed");
    Serial.println("disconnecting.");
    client.stop();
  }
}

void scroll(){
  char ms[resultt.length()];
   textLen = sizeof(ms) - 1;
   resultt.toCharArray(ms, sizeof(ms) - 1);
   lcd.clear();
   lcd.print(resultt);
  int len= resultt.length();

   Serial.println(resultt.length());
 // for (byte positionCounter = 0; positionCounter < resultt.length(); positionCounter++) {
 
    lcd.print( resultt.substring(0,15));
    lcd.setCursor(0, 1);
    lcd.print( resultt.substring(16,32));
    delay(5000);
    lcd.clear();
  if (len>32 and len<= 64){ 
    lcd.setCursor(0, 0);
    lcd.print( resultt.substring(32,48));
    lcd.setCursor(0, 1);
    lcd.print( resultt.substring(48,64));
    delay(5000);
  }
   if (len>64 and len<=96){ 
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print( resultt.substring(64,80));
    lcd.setCursor(0, 1);
    lcd.print( resultt.substring(80,96));
    delay(5000);

   }
 if (len>96 and len<= 128){ 
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print( resultt.substring(96,112));
    lcd.setCursor(0, 1);
    lcd.print( resultt.substring(112,128));
    delay(5000);

   }
  setup();
 // }
   result ="";
   resultt ="";
}

